#include "InterfaceHeader.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <check.h>
#include <pthread.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

/*
 * 
 */




int compare_two_binary_files(FILE *fp1, FILE *fp2) {
    char ch1, ch2;
    int flag = 0;
    while (((ch1 = fgetc(fp1)) != EOF) &&((ch2 = fgetc(fp2)) != EOF)) {
        if (ch1 == ch2) {
            flag = 1;
            continue;
        } else {
            fseek(fp1, -1, SEEK_CUR);
            flag = 0;
            break;
        }
    }

    if (ch1 == EOF) {

        ch2 = fgetc(fp2);
    }

    if ((ch1 != EOF) || (ch2 != EOF)) {
        flag = 0;
    }

    if (flag == 0) {
        return 1;
        //printf("Two files are not equal :  byte poistion at which two files differ is %d\n", ftell(fp1) + 1);

    } else {
        return 0;
        //printf("Two files are Equal\n ", ftell(fp1) + 1);
    }

}

START_TEST(test_1) {

    char * commandRemoveOldFile = "rm -f /home/alex/workspace/ResultsGENTRANS/results.out";
    system(commandRemoveOldFile);

    char * oracle = "/home/alex/workspace/ResultsGENTRANS/oraclePidginCflow1.out";

    char * currentResultsOutput = "/home/alex/workspace/ResultsGENTRANS/results.out";
    GRAFT_INTERFACE (NULL, "/home/alex/workspace/ResultsGENTRANS/HostDonorsNotInScript/CFlowTransplant/Donor/AuxFiles/src/argcv.c", currentResultsOutput, NULL, NULL, 1, NULL);
    FILE * resultsFile = fopen(currentResultsOutput,"r");
    FILE * oracleFile = fopen(oracle,"r");
    
    if (compare_two_binary_files(resultsFile, oracleFile)) {
        ck_abort();
    }
}

END_TEST



START_TEST(test_2) {

    char * commandRemoveOldFile = "rm -f /home/alex/workspace/ResultsGENTRANS/results.out";
    system(commandRemoveOldFile);

    char * oracle = "/home/alex/workspace/ResultsGENTRANS/oraclePidginCflow2.out";

    char * currentResultsOutput = "/home/alex/workspace/ResultsGENTRANS/results.out";
    GRAFT_INTERFACE (NULL, "/home/alex/workspace/ResultsGENTRANS/HostDonorsNotInScript/CFlowTransplant/Donor/AuxFiles/src/c.c", currentResultsOutput, NULL, NULL, 1, NULL);
    FILE * resultsFile = fopen(currentResultsOutput,"r");
    FILE * oracleFile = fopen(oracle,"r");
    
    if (compare_two_binary_files(resultsFile, oracleFile)) {
        ck_abort();
    }
}

END_TEST


START_TEST(test_3) {

    char * commandRemoveOldFile = "rm -f /home/alex/workspace/ResultsGENTRANS/results.out";
    system(commandRemoveOldFile);

    char * oracle = "/home/alex/workspace/ResultsGENTRANS/oraclePidginCflow3.out";

    char * currentResultsOutput = "/home/alex/workspace/ResultsGENTRANS/results.out";
    GRAFT_INTERFACE (NULL, "/home/alex/workspace/ResultsGENTRANS/HostDonorsNotInScript/CFlowTransplant/Donor/AuxFiles/src/gnu.c", currentResultsOutput, NULL, NULL, 1, NULL);
    FILE * resultsFile = fopen(currentResultsOutput,"r");
    FILE * oracleFile = fopen(oracle,"r");
    
    if (compare_two_binary_files(resultsFile, oracleFile)) {
        ck_abort();
    }
}

END_TEST


START_TEST(test_4) {

    char * commandRemoveOldFile = "rm -f /home/alex/workspace/ResultsGENTRANS/results.out";
    system(commandRemoveOldFile);

    char * oracle = "/home/alex/workspace/ResultsGENTRANS/oraclePidginCflow4.out";

    char * currentResultsOutput = "/home/alex/workspace/ResultsGENTRANS/results.out";
    GRAFT_INTERFACE (NULL, "/home/alex/workspace/ResultsGENTRANS/HostDonorsNotInScript/CFlowTransplant/Donor/AuxFiles/src/parser.c", currentResultsOutput, NULL, NULL, 1, NULL);
    FILE * resultsFile = fopen(currentResultsOutput,"r");
    FILE * oracleFile = fopen(oracle,"r");
    
    if (compare_two_binary_files(resultsFile, oracleFile)) {
        ck_abort();
    }
}

END_TEST


START_TEST(test_5) {

    char * commandRemoveOldFile = "rm -f /home/alex/workspace/ResultsGENTRANS/results.out";
    system(commandRemoveOldFile);

    char * oracle = "/home/alex/workspace/ResultsGENTRANS/oraclePidginCflow5.out";

    char * currentResultsOutput = "/home/alex/workspace/ResultsGENTRANS/results.out";
    GRAFT_INTERFACE (NULL, "/home/alex/workspace/ResultsGENTRANS/HostDonorsNotInScript/CFlowTransplant/Donor/AuxFiles/src/symbol.c", currentResultsOutput, NULL, NULL, 1, NULL);
    FILE * resultsFile = fopen(currentResultsOutput,"r");
    FILE * oracleFile = fopen(oracle,"r");
    
    if (compare_two_binary_files(resultsFile, oracleFile)) {
        ck_abort();
    }
}

END_TEST


Suite *
money_suite(void) {
    
    Suite *s = suite_create("GenTransSuite");
    // Core test case 
    TCase *tc_core = tcase_create("Core");
    tcase_set_timeout(tc_core, 15);
    tcase_add_test(tc_core, test_1);
    tcase_add_test(tc_core, test_2);
    tcase_add_test(tc_core, test_3);
    tcase_add_test(tc_core, test_4);
    tcase_add_test(tc_core, test_5);
    suite_add_tcase(s, tc_core);
    return s;
    
}

int main(int argc, char** argv) {
    
    int number_failed;
    Suite *s = money_suite();
    SRunner *sr = srunner_create(s);
    srunner_run_all(sr, CK_SILENT);

    printf("\n\n");

    srunner_print(sr, CK_NORMAL);

    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);
    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
    //  return (EXIT_SUCCESS);
    
    //test();
    
}
